
#ifndef __MUSITORIUS_ABSTRACT_PLAYER_H__
#define __MUSITORIUS_ABSTRACT_PLAYER_H__

#include"AbstractPlayerOutput.h"

//In paused state only stop() and restore() operations are allowed;
class AbstractPlayerCallback
{
public:
  virtual void onPlayerPosition(size_t secCurrent, size_t secTotal) = 0;
  virtual void onPlayerStop(int exitCode) = 0;
}; //class AbstractPlayerCallback;

class AbstractPlayer: public AbstractPlayerOutput
{
public:
  virtual ~AbstractPlayer() {}

  virtual void init() = 0;
  virtual bool play(const std::string& fileName, size_t volumeLevel) = 0;
  virtual void pause() = 0;
  virtual void resume() = 0;
  virtual void stop() = 0;
  virtual void jumpForward(size_t offset) = 0;
  virtual void jumpBackward(size_t offset) = 0;
  virtual void setVolume(size_t value) = 0;
  virtual void onSigChld(pid_t pid) = 0;
}; //class AbstractPlayer;

auto_ptr<AbstractPlayer> createMPlayerPlayer(const std::string& cmdLine, AbstractPlayerCallback& callback);

#endif //__MUSITORIUS_ABSTRACT_PLAYER_H__;
