

#include"musitorius.h"
#include"Client.h"

//FIXME:input line length limit;

Client::~Client()
{
  close();
}

void Client::notifyOnNewTask(const Task& task)
{
  //FIXME:
}

void Client::notifyOnNewTaskItem(TaskItemId taskItemId)
{
  //FIXME:
}

void Client::notifyOnNewPos(size_t pos, size_t total)
{
  //FIXME:
}

void Client::notifyOnNewVolume(size_t value)
{
  //FIXME:
}

void Client::notifyOnTaskFinish()
{
  //FIXME:
}

void Client::notifyOnIdle()
{
  //FIXME:
}

void Client::onCommandQueryIsIdle(ServerReply& reply)
{
  //FIXME:
}

void Client::onCommandQueryCurrentTask(ServerReply& reply)
{
  //FIXME:
}

void Client::onCommandQueryCurrentTaskItemId(ServerReply& reply)
{
  //FIXME:
}

void Client::onCommandQueryCurrentPos(ServerReply& reply)
{
  //FIXME:
}

void Client::onCommandNewTask(const Task& task, ServerReply& reply)
{
  m_callback.onNewTask(task);
  reply.type = ServerReplyBoolean;
  reply.booleanValue = 1;
}

void Client::onCommandPlay(ServerReply& reply)
{
  const bool value = m_callback.onPlayToggle();
  reply.type = ServerReplyBoolean;
  reply.booleanValue = value;
}

void Client::onCommandStop(ServerReply& reply)
{
  m_callback.onStop();
  reply.type = ServerReplyBoolean;
  reply.booleanValue = 1;
}

void Client::onCommandForward(size_t offset, ServerReply& reply)
{
  size_t newPos = 0, total = 0;//really unused in current version;
  m_callback.onForward(offset, newPos, total);
  reply.type = ServerReplyBoolean;
  reply.booleanValue = 1;
}

void Client::onCommandBackward(size_t offset, ServerReply& reply)
{
  size_t newPos = 0, total = 0;//really unused in current version;
  m_callback.onBackward(offset, newPos, total);
  reply.type = ServerReplyBoolean;
  reply.booleanValue = 1;
}

void Client::onCommandNext(ServerReply& reply)
{
  //We have id of new task item here but do not give it to protocol, currently it is not clear how it must be performed;
  m_callback.onNext();
  reply.type = ServerReplyBoolean;
  reply.booleanValue = 1;
}

void Client::onCommandPrevious(ServerReply& reply)
{
  //We have id of new task item here but do not give it to protocol, currently it is not clear how it must be performed;
  m_callback.onPrevious();
  reply.type = ServerReplyBoolean;
  reply.booleanValue = 1;
}

void Client::onCommandTaskItem(TaskItemId taskItemId, ServerReply& reply)
{
  //FIXME:
}

void Client::onCommandIncreaseVolume(size_t step, ServerReply& reply)
{
  //FIXME:
}

void Client::onCommandDecreaseVolume(size_t step, ServerReply& reply)
{
  //FIXME:
}

void Client::onCommandSwitchToListen()
{
  m_listenMode = 1;
}

void Client::onProtocolOutput(const std::string& output)
{
  //FIXME:incomplete write operation;
  ::write(m_fd, output.c_str(), output.length());
  ::write(m_fd, "\n", 1);
}

//The following method returns non-zero if connection must be closed;
bool Client::readData()
{
  char buf[2048];
  const ssize_t res = ::read(m_fd, buf, sizeof(buf));
  if (res < 0)
    {
      logMsg(LOG_ERR, "Error reading client data (%s), fd=%d", ERRNO_MSG, m_fd);
      return 1;
    }
  if (res == 0)
    return 1;
  logMsg(LOG_DEBUG, "Read %u bytes of data from client", res);
  for(size_t i = 0;i < (size_t)res;i++)
    m_inputChain += buf[i];
  TextQueue<std::string> queue(m_inputChain);
  std::string s;
  while (queue.next(s))
    m_protocol.processInputLine(s);
  m_inputChain = queue.chain();
  return 0;
}

void Client::close()
{
  if (m_fd == 0)
    return;
  ::close(m_fd);
  m_fd = 0;
}

int Client::getHandler() const
{
  assert(m_fd != 0);
  return m_fd;
}
