
#ifndef __MUSITORIUS_MAIN_LOOP_H__
#define __MUSITORIUS_MAIN_LOOP_H__

#include "ClientFactory.h"
#include"AbstractPlayerOutput.h"

class AbstractSignalHandler
{
public:
  virtual ~AbstractSignalHandler() {}
  virtual void onSystemSignal() = 0;
}; //class AbstractSignalHandler;

class MainLoop
{
public:
  MainLoop(const ClientFactory& clientFactory, ClientList& clients, size_t maxClients, AbstractSignalHandler& signalHandler, AbstractPlayerOutput& playerOutput, bool& terminationFlag)
    : m_clientFactory(clientFactory), m_connectedClients(clients), m_maxClients(maxClients), m_signalHandler(signalHandler), m_playerOutput(playerOutput), m_terminationFlag(terminationFlag) {}

  void run(const SocketList& sockets, sigset_t* sigMask);

private:
  const ClientFactory& m_clientFactory;
  ClientList& m_connectedClients;
  const size_t m_maxClients;
  AbstractSignalHandler& m_signalHandler;
  AbstractPlayerOutput& m_playerOutput;
  bool& m_terminationFlag;
}; //class MainLoop;

#endif //__MUSITORIUS_MAIN_LOOP_H__
