

#include"musitorius.h"
#include"Task.h"

void Task::initAsFileNames(const StringList& fileNames)
{
  m_items.clear();
  m_items.reserve(fileNames.size());
  for(StringList::const_iterator it = fileNames.begin();it != fileNames.end();++it)
    m_items.push_back(*it);
}

void Task::clear()
{
  m_items.clear();
}

bool Task::empty() const
{
  return m_items.empty();
}

size_t Task::getItemCount() const
{
  return m_items.size();
}

std::string Task::itemFileName(TaskItemId taskItemId) const
{
  assert(taskItemId < m_items.size());
  return m_items[taskItemId];
}

bool Task::hasTaskItem(TaskItemId taskItemId) const
{
  assert(taskItemId != BAD_TASK_ITEM_ID);
  return taskItemId < m_items.size();
}

TaskItemId Task::startingItemId() const
{
  return m_items.empty()?BAD_TASK_ITEM_ID:0;
}

TaskItemId Task::nextTaskItemId(TaskItemId taskItemId) const
{
  return taskItemId + 1 < m_items.size()?taskItemId + 1:BAD_TASK_ITEM_ID;
}

TaskItemId Task::prevTaskItemId(TaskItemId taskItemId) const
{
  return taskItemId > 0?taskItemId - 1:BAD_TASK_ITEM_ID;
}
