
#include"musitorius.h"
#include"Socket.h"

void Socket::open(const std::string &name)
{
  assert(!m_opened);
  unlink(name.c_str());
  struct sockaddr_un addr;
  int fd = socket(AF_UNIX, SOCK_STREAM, 0);
  MUSITORIUS_SYS(fd!=-1, "socket(AF_UNIX, SOCK_STREAM, 0)");
  addr.sun_family=AF_UNIX;
  strncpy(addr.sun_path, name.c_str(), sizeof(addr.sun_path));
  if (bind(fd, (struct sockaddr*)&addr, sizeof(sockaddr_un)) == -1)
    {
      ::close(fd);
      throw SystemException("bind()");
    }
  if (listen(fd, 512) == -1)
    {
      ::close(fd);
      throw SystemException("listen()");
    }
  chmod(name.c_str(), 0666);
  m_sock=fd;
  m_opened=1;
  m_fileName = name;
}

int Socket::accept() const
{
  int fd = ::accept(m_sock, NULL, NULL);
  MUSITORIUS_SYS(fd != -1, "accept()");
  return fd;
}

void Socket::close()
{
  if (!m_opened)
    return;
  ::close(m_sock);
  m_opened = 0;
}

int Socket::getHandler() const
{
  assert(m_opened);
  return m_sock;
}

std::string Socket::getFileName() const
{
  assert(m_opened);
  return m_fileName;
}

bool Socket::opened() const
{
  return m_opened;
}
