
#ifndef __MUSITORIUS_SOCKETS_H__
#define __MUSITORIUS_SOCKETS_H__

class Socket
{
public:
  Socket()
    : m_sock(0), m_opened(0) {}

  virtual ~Socket() {close();}

  void open(const std::string& name);
  int accept() const;
  void close();
  int getHandler() const;
  std::string getFileName() const;
  bool opened() const;

private:
  int m_sock;
  std::string m_fileName;
  bool m_opened;
}; //class Socket;

typedef std::list<Socket*> SocketList;
typedef std::vector<Socket*> SocketVector;

#endif // __MUSITORIUS_SOCKETS_H__
