
#ifndef __MUSITORIUS_H__
#define __MUSITORIUS_H__

#include"main/system.h"
#include"main/logging.h"
#include"MusitoriusException.h"
#include"main/SystemException.h"
#include"main/Socket.h"
#include"string-utils.h"

using std::auto_ptr;

typedef std::list<std::string> StringList;
typedef std::vector<std::string> StringVector;
typedef std::vector<bool> BoolVector;

//some utils;
template<class TStr>
bool stringEnds(const TStr& str, const TStr& end)
{
  if (end.length() > str.length())
    return 0;
  for(typename TStr::size_type i = 0;i < end.length();i++)
    if (end[i] != str[str.length() - end.length() + i])
      return 0;
  return 1;
}

template<class TStr, class TList>
void splitTextFileLines(const TStr& text, TList& lines, bool trimLines, bool skipEmpty)
{
  TStr s;
  lines.clear();
  for(typename TStr::size_type i = 0;i < text.length();i++)
    {
      if (text[i] == '\r')
	continue;
      if (text[i] == '\n')
	{
	  if (trimLines)
	    s = trim(s);
	  if (!skipEmpty || !s.empty())
	    lines.push_back(s);
	  s.erase();
	  continue;
	}
      s += text[i];
    } //for(text[i]);
  if (trimLines)
    s = trim(s);
  if (!skipEmpty && !s.empty())
    lines.push_back(s);
}

ssize_t readBlock(int fd, void* buf, size_t bufSize);
ssize_t writeBlock(int fd, const void* buf, size_t bufSize);
ssize_t readBuffer(int fd, void* buf, size_t bufSize);
ssize_t writeBuffer(int fd, const void* buf, size_t bufSize);
std::string readTextFile(const std::string& fileName);

#endif //__MUSITORIUS_H__
