
#ifndef __MUSITORIUS_MPLAYER_H__
#define __MUSITORIUS_MPLAYER_H__

#include"core/AbstractPlayer.h"
#include"core/AbstractPlayerOutput.h"

class MPlayer: public AbstractPlayer
{
public:
  MPlayer(const std::string& cmdLine, AbstractPlayerCallback& callback)
    : m_cmdLine(cmdLine), m_callback(callback), m_pid(0) {}
  virtual ~MPlayer() {}

public://AbstractPlayer;
  void init();
  bool play(const std::string& fileName, size_t volumeLevel);
  void pause();
  void resume();
  void stop();
  void jumpForward(size_t offset);
  void jumpBackward(size_t offset);
  void setVolume(size_t value);
  void onSigChld(pid_t pid);

public://AbstractPlayerOutput;
  int getOutputFd() const;
  int getErrorFd() const;
  void readOutputData();
  void readErrorData();

private:
  void sendCommand(const std::string& command);

private:
  std::string m_cmdLine;
  AbstractPlayerCallback& m_callback;
  pid_t m_pid;
  int m_inputPipe[2], m_outputPipe[2], m_errorPipe[2];
  std::string m_outputChain, m_errorChain;
  bool m_paused;
}; //class Mplayer;

#endif //__MUSITORIUS_MPLAYER_H__;
