
#ifndef __MUSITORIUS_CLIENT_LIBRARY__
#define __MUSITORIUS_CLIENT_LIBRARY__

#ifdef __cplusplus 
#define EXTC extern "C"
#else
#define EXTC extern
#endif /* __cplusplus*/

typedef int musitorius_connection_t;
#define MUSITORIUS_BAD_CONNECTION (musitorius_connection_t)-1

typedef int musitorius_result_t;
#define MUSITORIUS_GENERAL_OK 1
#define MUSITORIUS_GENERAL_ERROR 0
#define MUSITORIUS_OK(x) ((x) == MUSITORIUS_GENERAL_OK)

typedef struct musitorius_string_list_item_t_ {
  char* value;
  struct musitorius_string_list_item_t_ *next;
} musitorius_string_list_item_t;

typedef struct musitorius_string_list_t_ {
  musitorius_string_list_item_t* first;
  musitorius_string_list_item_t* last;
} musitorius_string_list_t;

EXTC void musitorius_string_list_init(musitorius_string_list_t* list);
EXTC char musitorius_string_list_add(musitorius_string_list_t*list, char* value);
EXTC void musitorius_string_list_destroy(musitorius_string_list_t* list);

EXTC musitorius_connection_t musitorius_connect(char* path);
EXTC void musitorius_close(musitorius_connection_t connection);
EXTC musitorius_result_t musitorius_task_single_file(musitorius_connection_t connection, char* path);
EXTC musitorius_result_t musitorius_task(musitorius_connection_t connection, musitorius_string_list_t* list);
EXTC musitorius_result_t musitorius_play(musitorius_connection_t connection);
EXTC musitorius_result_t musitorius_stop(musitorius_connection_t connection);
EXTC musitorius_result_t musitorius_next(musitorius_connection_t connection);
EXTC musitorius_result_t musitorius_prev(musitorius_connection_t connection);
EXTC musitorius_result_t musitorius_forward(musitorius_connection_t connection, size_t step);
EXTC musitorius_result_t musitorius_backward(musitorius_connection_t connection, size_t step);

#endif /*__MUSITORIUS_CLIENT_LIBRARY__*/
