
#ifndef __MUSITORIUS_CMD_ARGS_PARSER_H__
#define __MUSITORIUS_CMD_ARGS_PARSER_H__

//Taken from VoiceMan at 2011-01-07;

struct CmdArg
{
  char shortName;
  const char* longName;
  const char* param;
  const char*descr;
}; //struct CmdArg;

class CmdArgsParser
{
public:
  CmdArgsParser(CmdArg* allParams);

  void printHelp() const;
  bool used(const std::string& name) const;
  const std::string operator [](const std::string& name) const;
  bool parse(int argc, char* argv[]);

public:
  const std::vector<std::string>& files;

private:
  struct USEDPARAM
  {
    USEDPARAM() 
      : hasValue(0) {}

    std::string name, value;
    bool hasValue;
  }; //struct USEDPARAM;

  typedef std::vector<USEDPARAM> UsedParamVector;

private:
  size_t identifyParam(char* p) const;

private:
  typedef std::vector<std::string> StringVector;

  StringVector m_files;
    UsedParamVector m_usedParams;
    CmdArg* m_availableParams;
  size_t m_availableParamCount;
}; // class Cmdargs;

#endif //__MUSITORIUS_CMD_ARGS_PARSER_H__
